# TODO:
# - check mppc patch
# - check if %{_libdir}/pppd/%{version} path is needed, if not drop the symlink

# Conditional build:
%bcond_without	pppoatm	# without PPPoATM plugin (which requires kernel 2.4 and atm-devel)
%bcond_without	srp	# without SRP support
#
Summary:	ppp daemon package for Linux
Summary(de.UTF-8):	ppp-Dämonpaket für Linux
Summary(es.UTF-8):	Servidor ppp para Linux
Summary(fr.UTF-8):	Paquetage du démon ppp pour Linux
Summary(pl.UTF-8):	Demon PPP dla Linuksa
Summary(pt_BR.UTF-8):	Servidor ppp para Linux
Summary(ru.UTF-8):	Демон ppp
Summary(tr.UTF-8):	PPP sunucu süreci
Summary(zh_CN.UTF-8):	PPP 配置和管理软件包.
Name:		ppp
Version:	2.4.5
Release:	7
Epoch:		3
License:	distributable
Group:		Networking/Daemons
Source0:	ftp://ftp.samba.org/pub/ppp/%{name}-%{version}.tar.gz
# Source0-md5:	4621bc56167b6953ec4071043fe0ec57
Source1:	%{name}.pamd
Source2:	%{name}.pon
Source3:	%{name}.poff
Source4:	http://www.mif.pg.gda.pl/homepages/ankry/man-PLD/%{name}-non-english-man-pages.tar.bz2
# Source4-md5:	3801b59005bef8f52856300fe3167a64
Source5:	%{name}.logrotate
Patch0:		%{name}-make.patch
Patch1:		%{name}-expect.patch
Patch2:		%{name}-debian_scripts.patch
Patch3:		%{name}-static.patch
Patch4:		%{name}-pidfile-owner.patch
Patch6:		%{name}-rp-pppoe-macaddr.patch
#Patch7:		http://public.planetmirror.com/pub/mppe/pppd-2.4.2-chapms-strip-domain.patch.gz
Patch7:		pppd-2.4.2-chapms-strip-domain.patch
Patch8:		%{name}-openssl.patch
Patch9:		%{name}-lib64.patch
#Patch10:	http://mppe-mppc.alphacron.de/%{name}-2.4.3-mppe-mppc-1.1.patch.gz
Patch10:	%{name}-2.4.3-mppe-mppc-1.1.patch
Patch11:	%{name}-llc.patch
Patch12:	%{name}-llh.patch
Patch13:	%{name}-ifpppstatsreq.patch 
URL:		http://www.samba.org/ppp/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libpcap-devel >= 2:0.8.1
BuildRequires:	libtool
%{?with_pppoatm:BuildRequires:	linux-atm-devel}
# <linux/if_pppol2tp.h>
BuildRequires:	linux-libc-headers >= 7:2.6.23
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
%{?with_srp:BuildRequires:	srp-devel}
Requires:	pam >= 0.77.3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is the daemon and documentation for PPP support. It requires a
kernel greater than 2.2.11 which is built with PPP support. The
default kernels include PPP support as a module. This version supports
IPv6, too.

%description -l de.UTF-8
Dies ist der Dämon und die Dokumentation für PPP-Support. Erfordert
einen Kernel höher als 2.2.11, der mit PPP-Support gebaut ist. Die
Standard-Kernel schließen PPP-Support als Modul ein. (IPv6)

%description -l es.UTF-8
Este es el servidor y la documentación para soporte PPP. Requiere un
kernel superior al 2.0.

%description -l fr.UTF-8
Ceci est le démon et la documentation pour le support PPP. Cela
réclame un noyau supérieur au 2.2.11 et construit avec le support PPP.

%description -l pl.UTF-8
Pakiet zawiera demona i dokumentację umożliwiającą korzystanie z
protokołu PPP. Wymaga jądra 2.2.11 - lub późniejszego - z wkompilowaną
obsługą protokołu PPP. Standardowe jądro z dystrybucji zawiera
wsparcie dla PPP skompilowane jako moduł. (IPv6)

%description -l pt_BR.UTF-8
Este é o servidor e a documentação para suporte PPP. Ele requer um
kernel superior ao 2.0.

%description -l ru.UTF-8
Демон, конфигурационные файлы и документация для поддержки PPP.

%description -l tr.UTF-8
Bu paket PPP desteği için belgeler ve sunucu sürecini içerir. Çekirdek
sürümünun 2.2.11'dan daha yüksek olmasını gerektirir.

%package plugin-devel
Summary:	Stuff needed to build plugins for pppd
Summary(pl.UTF-8):	Rzeczy potrzebne do budowania wtyczek dla pppd
Group:		Development/Libraries
# doesn't require base but enforce new version
Conflicts:	%{name} < %{epoch}:%{version}-%{release}

%description plugin-devel
Development files needed to build plugins for pppd.

%description plugin-devel -l pl.UTF-8
Pliki nagłówkowe potrzebne do budowania wtyczek dla pppd.

%package plugin-pppoatm
Summary:	PPPoATM plugin for pppd
Summary(pl.UTF-8):	Wtyczka PPPoATM dla pppd
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description plugin-pppoatm
PPPoATM plugin for pppd.

%description plugin-pppoatm -l pl.UTF-8
Wtyczka PPPoATM dla pppd.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%if "%{_lib}" == "lib64"
%patch9 -p1
%endif
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

# use headers from llh instead of older supplied by ppp, incompatible with current llh
%{__rm} include/linux/*.h

%build
# note: not autoconf configure
%configure
%{__make} \
	%{?with_pppoatm:HAVE_LIBATM=y} \
	%{?with_srp:USE_SRP=y} \
	OPT_FLAGS="%{rpmcflags} %{rpmcppflags}" \
	COPTS="%{rpmcflags} %{rpmcppflags}" \
	OPTLDFLAGS="%{rpmldflags}" \
	CC="%{__cc}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_sysconfdir}/ppp/peers,/var/log} \
	$RPM_BUILD_ROOT/etc/{pam.d,logrotate.d}

%{__make} install \
	%{?with_pppoatm:HAVE_LIBATM=y} \
	%{?with_srp:USE_SRP=y} \
	DESTDIR=$RPM_BUILD_ROOT%{_prefix}

install -p %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/pon
install -p %{SOURCE3} $RPM_BUILD_ROOT%{_bindir}/poff
install -p debian/plog $RPM_BUILD_ROOT%{_bindir}

cp -p etc.ppp/chap-secrets $RPM_BUILD_ROOT%{_sysconfdir}/ppp
cp -p debian/pap-secrets $RPM_BUILD_ROOT%{_sysconfdir}/ppp
cp -p debian/options $RPM_BUILD_ROOT%{_sysconfdir}/ppp
cp -p debian/options.ttyXX $RPM_BUILD_ROOT%{_sysconfdir}/ppp

bzip2 -dc %{SOURCE4} | tar xf - -C $RPM_BUILD_ROOT%{_mandir}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/README.ppp-non-english-man-pages

cp -p %{SOURCE5} $RPM_BUILD_ROOT/etc/logrotate.d/ppp
> $RPM_BUILD_ROOT/var/log/ppp.log

rm -f scripts/README

cp -p %{SOURCE1} $RPM_BUILD_ROOT/etc/pam.d/ppp

cd $RPM_BUILD_ROOT%{_libdir}/pppd
v=$(echo %{version}*)
mv $v plugins
# not sure which path used, keep the old path for compat
ln -s plugins $v

%clean
rm -rf $RPM_BUILD_ROOT

%pretrans
# %{version} used to be directory
if [ -d %{_libdir}/pppd/%{version} -a ! -L %{_libdir}/pppd/%{version} ]; then
	set -e
	rm -f %{_libdir}/pppd/plugins
	mv %{_libdir}/pppd/{%{version},plugins}
	ln -sn plugins %{_libdir}/pppd/%{version}
fi

%files
%defattr(644,root,root,755)
%doc README.linux debian/README.debian scripts
%doc debian/win95.ppp README.MSCHAP8* FAQ debian/ppp-2.3.0.STATIC.README
%doc README.MPPE README.pppoe README.cbcp README.pwfd
%attr(755,root,root) %{_bindir}/plog
%attr(755,root,root) %{_bindir}/poff
%attr(755,root,root) %{_bindir}/pon
%attr(755,root,root) %{_sbindir}/chat
%attr(755,root,root) %{_sbindir}/pppd
%attr(755,root,root) %{_sbindir}/pppdump
%attr(755,root,root) %{_sbindir}/pppoe-discovery
%attr(755,root,root) %{_sbindir}/pppstats
%{?with_srp:%attr(755,root,root) %{_sbindir}/srp-entry}
%dir %{_libdir}/pppd
%dir %{_libdir}/pppd/plugins
%attr(755,root,root) %{_libdir}/pppd/plugins/minconn.so
%attr(755,root,root) %{_libdir}/pppd/plugins/openl2tp.so
%attr(755,root,root) %{_libdir}/pppd/plugins/pppol2tp.so
%attr(755,root,root) %{_libdir}/pppd/plugins/passprompt.so
%attr(755,root,root) %{_libdir}/pppd/plugins/passwordfd.so
%attr(755,root,root) %{_libdir}/pppd/plugins/rp-pppoe.so
%attr(755,root,root) %{_libdir}/pppd/plugins/radattr.so
%attr(755,root,root) %{_libdir}/pppd/plugins/radius.so
%attr(755,root,root) %{_libdir}/pppd/plugins/radrealms.so
%attr(755,root,root) %{_libdir}/pppd/plugins/winbind.so

# TODO: legacy, try to drop
%{_libdir}/pppd/%{version}

%{_mandir}/man8/chat.8*
%{_mandir}/man8/pppd.8*
%{_mandir}/man8/pppd-radattr.8*
%{_mandir}/man8/pppd-radius.8*
%{_mandir}/man8/pppdump.8*
%{_mandir}/man8/pppstats.8*
%lang(fr) %{_mandir}/fr/man8/*
%lang(ja) %{_mandir}/ja/man8/*
%lang(ko) %{_mandir}/ko/man8/*
%lang(pl) %{_mandir}/pl/man8/*

%attr(600,root,root) %config(missingok,noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ppp/chap-secrets
%attr(600,root,root) %config(missingok,noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ppp/pap-secrets
%config(missingok,noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ppp/options
%config(missingok,noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ppp/options.ttyXX
%dir %{_sysconfdir}/ppp/peers
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/ppp
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/ppp
%attr(640,root,root) %ghost /var/log/ppp.log

%files plugin-devel
%defattr(644,root,root,755)
%{_includedir}/pppd

%if %{with pppoatm}
%files plugin-pppoatm
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/pppd/plugins/pppoatm.so
%endif
%changelog
* Sat Feb 16 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> baa04c3
- struct ifpppstatsreq no longer there, replace by newer interfaces

* Mon Apr 02 2012 Elan Ruusamäe <glen@pld-linux.org> e682762
- dir to symlink conflict resolving on upgrade

* Mon Apr 02 2012 Elan Ruusamäe <glen@pld-linux.org> 143250a
- use %{_libdir}/pppd/plugins dir, add todo about versioned dir drop

* Sat Jan 29 2011 sparky <sparky@pld-linux.org> c360d2b
- dropped pre-cvs changelog

* Fri Oct 29 2010 hawk <hawk@pld-linux.org> ea22efb
- release 5

* Fri Oct 29 2010 hawk <hawk@pld-linux.org> 5c5e0fc
- release 4

* Mon Aug 30 2010 hawk <hawk@pld-linux.org> c9e45f9
- release 3

* Sun Aug 22 2010 Jakub Bogusz <qboosh@pld-linux.org> 8135f73
- added llh patch, use headers from llh (now builds with current llh; needs 2.6.23 at least)
- simplified install, more verbose files
- package all installed devel headers

* Sun May 23 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> ea549e8
- rel 2; fix files on x86_64

* Sun May 23 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 6936cab
- up to 2.4.5

* Sun Apr 11 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 7a5acd2
- release 4

* Sat Apr 03 2010 Elan Ruusamäe <glen@pld-linux.org> b3def8b
- release 3

* Thu Jan 03 2008 Patryk Zawadzki <patrys@room-303.com> 8a86b01
- build against recent llh
- package more files

* Thu Jan 03 2008 Patryk Zawadzki <patrys@room-303.com> ff490c4
- build against recent llh

* Sun Jul 01 2007 Jakub Bogusz <qboosh@pld-linux.org> f681d1a
- real information for previous commit

* Sat Jun 30 2007 Arkadiusz Miśkiewicz <arekm@maven.pl> 6a91749
- up to 2.4.4
[actually just release 1]

* Tue Mar 27 2007 Jan Rękorajski <baggins@pld-linux.org> bc18228
- uniformized configs to use system-auth where possible
- sanitized
- uniform blacklist for pop3, imap and smtp services

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> f4287ca
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 1826846
- converted to UTF-8

* Fri Aug 04 2006 sparky <sparky@pld-linux.org> 90be4f7
- more $(OPTLDFLAGS)

